import 'package:deep_collection/deep_collection.dart';
import 'package:test/test.dart';

void main() {
  final map = {
    'c': 'cc',
    'a': 'aa',
    'x': {
      'a',
      'b',
      'c',
      [
        'c',
        'a',
        'b',
      ],
    },
    'g': [
      'c',
      'a',
      'b',
    ],
    'b': {
      'a': {
        'a',
        {
          'a',
          'b',
          'c',
        },
        [
          'c',
          'a',
          'b',
        ],
        {
          'c': 'cc',
          'a': 'aa',
        },
      },
      'x': 'xx',
      'z': {
        'c': 'cc',
        'a': 'aa',
        'd': [
          'c',
          'a',
          'b',
        ],
      },
      'y': [
        {
          'b': 'bb',
          'a': 'aa',
        },
        'a',
        [
          'a',
          'b',
          'c',
        ],
        {
          'x',
          'z',
          {
            'c': 'cc',
            'b': 'bb',
            'a': 'aa',
          },
        },
      ],
    },
    'f': {
      'b': 'bb',
      'a': 'aa',
    },
    3: 1,
    1: 3,
    true: false,
    null: true,
    false: true,
    4: {
      1,
      3,
      2,
      [
        3,
        1,
        2,
      ],
    },
    5: [
      3,
      5,
      5,
      2,
    ],
    2: {
      1: {
        1,
        {
          7,
          2,
          3,
        },
        [
          3,
          3,
          1,
          2,
        ],
        {
          3: 3,
          1: 1,
        },
      },
      4: 9,
      6: {
        3: 3,
        1: 1,
        7: [
          3,
          1,
          1,
          1,
          2,
        ],
      },
      8: [
        {
          2: 2,
          1: 1,
        },
        1,
        [
          1,
          2,
          3,
          1,
          2,
          3,
        ],
        {
          4,
          6,
          {
            3: 3,
            2: 2,
            1: 1,
          },
        },
      ],
    },
    9: {
      2: 2,
      1: 1,
    },
    3.3: 1.1,
    1.1: 3.3,
    4.4: {
      1.1,
      3.3,
      2.2,
      [
        3.3,
        1.1,
        2.2,
      ],
    },
    5.5: [
      3.3,
      5.5,
      2.2,
    ],
    2.2: {
      1.1: {
        1.1,
        {
          7.7,
          2.2,
          3.3,
        },
        [
          3.3,
          1.1,
          2.2,
        ],
        {
          3.3: 3.3,
          1.1: 1.1,
        },
      },
      4.4: 9.9,
      6.6: {
        3.3: 3.3,
        1.1: 1.1,
        7.7: [
          3.3,
          1.1,
          2.2,
        ],
      },
      8.8: [
        {
          2.2: 2.2,
          1.1: 1.1,
        },
        1.1,
        [
          1.1,
          2.2,
          3.3,
        ],
        {
          4.4,
          6.6,
          {
            3.3: 3.3,
            2.2: 2.2,
            1.1: 1.1,
          },
        },
      ],
    },
    9.9: {
      2.2: 2.2,
      1.1: 1.1,
    },
  };

  final expectedReversed = {
    9.9: {1.1: 1.1, 2.2: 2.2},
    2.2: {
      8.8: [
        {
          {1.1: 1.1, 2.2: 2.2, 3.3: 3.3},
          6.6,
          4.4
        },
        [3.3, 2.2, 1.1],
        1.1,
        {1.1: 1.1, 2.2: 2.2}
      ],
      6.6: {
        7.7: [2.2, 1.1, 3.3],
        1.1: 1.1,
        3.3: 3.3
      },
      4.4: 9.9,
      1.1: {
        {1.1: 1.1, 3.3: 3.3},
        [2.2, 1.1, 3.3],
        {3.3, 2.2, 7.7},
        1.1
      }
    },
    5.5: [2.2, 5.5, 3.3],
    4.4: {
      [2.2, 1.1, 3.3],
      2.2,
      3.3,
      1.1
    },
    1.1: 3.3,
    3.3: 1.1,
    9: {1: 1, 2: 2},
    2: {
      8: [
        {
          {1: 1, 2: 2, 3: 3},
          6,
          4
        },
        [3, 2, 1, 3, 2, 1],
        1,
        {1: 1, 2: 2}
      ],
      6: {
        7: [2, 1, 1, 1, 3],
        1: 1,
        3: 3
      },
      4: 9,
      1: {
        {1: 1, 3: 3},
        [2, 1, 3, 3],
        {3, 2, 7},
        1
      }
    },
    5: [2, 5, 5, 3],
    4: {
      [2, 1, 3],
      2,
      3,
      1
    },
    false: true,
    null: true,
    true: false,
    1: 3,
    3: 1,
    'f': {'a': 'aa', 'b': 'bb'},
    'b': {
      'y': [
        {
          {'a': 'aa', 'b': 'bb', 'c': 'cc'},
          'z',
          'x'
        },
        ['c', 'b', 'a'],
        'a',
        {'a': 'aa', 'b': 'bb'}
      ],
      'z': {
        'd': ['b', 'a', 'c'],
        'a': 'aa',
        'c': 'cc'
      },
      'x': 'xx',
      'a': {
        {'a': 'aa', 'c': 'cc'},
        ['b', 'a', 'c'],
        {'c', 'b', 'a'},
        'a'
      }
    },
    'g': ['b', 'a', 'c'],
    'x': {
      ['b', 'a', 'c'],
      'c',
      'b',
      'a'
    },
    'a': 'aa',
    'c': 'cc'
  };

  test('reverse complex', () {
    final reversedMap = map.deepReverse();

    expect(reversedMap.toString(), equals(expectedReversed.toString()));
  });
}
